/*--------------------------------------------------------------------------
main.c 20200420
Demo file for Nuvoton N76E003 (SDCC version)
You must set or #define FOSC_160000 before it will compile!
--------------------------------------------------------------------------*/

#include "N76E003.h"
//#include "Common.h"
#include "Delay.h"
#include "SFR_Macro.h"
#include "Function_define.h"

void delay1ms(unsigned char d)	//Software delay in ms
{
	d;							//Must declare delay variable d
	__asm
			MOV R2,dpl			//Variable d was passed via dpl
	00001$: MOV R1,#0x08		//8 x 12.5ms produces 1ms total
	00002$:	MOV R0,#0xFA		//FA is 12.5ms (or C7 is 100us)
	00003$: DJNZ R0,00003$
			DJNZ R1,00002$
			DJNZ R2,00001$
	__endasm;
}

void main(void)
{
	P14_Quasi_Mode;	//Configure Port 1 Pin 4 to drive debug LED
   while(1)
   {
	   P14 = 1;					//Turn LED off
	   Timer1_Delay10ms(50);	//Timer delay 500ms
	   P14 = 0;					//Turn LED on
	   delay1ms(250);			//Software delay 250ms
   }
}
